#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

const unsigned int ARRAY_SIZE = 0x500000;
const unsigned int PROCESSES = 2;

void populate_array(int* array, unsigned int elements)
{
	for(unsigned int i=0 ; i<elements ; i++)
	{
		array[i] = random();
	}
}

int average_array(int* array, unsigned int elements)
{
	long long total = 0;
	for(unsigned int i=0 ; i<elements ; i++)
	{
		total += array[i];
	}
	return total / elements;
}

int main(void)
{
	unsigned int array_size = ARRAY_SIZE / PROCESSES;
	//Fork off PROCESSES children:
	for(unsigned int child=0 ; child<PROCESSES ; child++)
	{
		pid_t pid = fork();
		if(pid == 0)
		{
			//We are in a child process
			int * array = calloc(array_size, sizeof(int));
			populate_array(array, array_size);
			exit(average_array(array, array_size));
		}
	}
	//Array to store child results in:
	int child_averages[PROCESSES];
	for(unsigned int i=0 ; i<PROCESSES ; i++)
	{
		wait(&child_averages[i]);
	}
	printf("Average: %d\n", average_array(child_averages, PROCESSES));
	return 0;
}
