#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <unistd.h>
#include <semaphore.h>



int main(void)
{
	//Counter in shared memory region:
	int * counter = mmap(0,
			sizeof(int), 
			PROT_READ | PROT_WRITE,
		   	MAP_SHARED | MAP_ANON,
		   	-1,
			0);
	*counter = 0;
	//Semaphore for locking:
	sem_t * lock = sem_open("example_lock", O_CREAT | O_EXCL, 0600, 1);
	//Do the same thing in two processes
	fork();
	//Random number from 0-255
	unsigned int max = random() & 255;
	//Increment the counter max times
	for(unsigned int i=0; i<max ; i++)
	{
		sem_wait(lock);
		(*counter)++;
		sem_post(lock);
	}
	printf("Added %u to counter.  Final value is: %d\n", max,*counter);
	return 0;
}
